Object Lifecycle Management helps you optimize storage costs and automate data retention by setting lifecycle rules on a bucket. For example, you can transition objects to colder storage classes or delete expired data.
You can configure and view lifecycle rules on a bucket. These rules apply to all current and future objects in that bucket.
For background information, see Object Lifecycle Management.
Required roles
To get the permissions that you need to set and manage Object Lifecycle
Management for a bucket, ask your administrator to grant you the Storage Admin
(roles/storage.admin) role on the bucket. This predefined role contains
the permissions required to set and manage Object Lifecycle Management for a
bucket. To see the exact permissions required, expand the
Required permissions section:
Required permissions
storage.buckets.getstorage.buckets.list- You only need this permission if you use the Google Cloud console to perform the instructions on this page.
storage.buckets.update
You might also be able to get these permissions with custom roles.
For information about granting roles on buckets, see Set and manage Identity and Access Management policies on buckets.
Set the lifecycle configuration for a bucket
When you change your lifecycle configuration, Object Lifecycle Management might
continue to perform actions based on the previous configuration for up to 24
hours. For example, if you change an age condition from 10 days to 20 days,
Object Lifecycle Management can still delete an 11-day-old object for up to 24
hours based on the previous configuration.
Some lifecycle configurations can generate unexpected charges, such as
transitioning millions of small objects with SetStorageClass or deleting
objects that are stored in Nearline storage, Coldline storage, or
Archive storage before they reach their minimum storage duration. Before you
apply a lifecycle configuration, see Mitigate lifecycle management costs.
Console
- In the Google Cloud console, go to the Cloud Storage Buckets page.
In the bucket list, find the bucket you want to enable, and click the bucket's name.
Click the Lifecycle tab.
The lifecycle rules page appears. From here you can edit or delete existing rules. To add a new rule:
Click Add a rule.
In the page that appears, specify a configuration.
Select the action to take when an object meets the conditions.
Click Continue.
Select the conditions under which an action is taken.
Click Continue.
Click Create.
To learn how to get detailed error information about failed Cloud Storage operations in the Google Cloud console, see Troubleshooting.
Command line
If you want to retain existing lifecycle rules on the bucket, then get the current lifecycle configuration and save it to a JSON file. Otherwise, create a new JSON file.
Update the JSON file to include all the lifecycle configuration rules that you want to apply to the bucket. Applying a configuration file replaces any existing lifecycle rules on the bucket. For sample JSON files, see Configuration examples.
Use the
gcloud storage buckets updatecommand with the--lifecycle-fileflag:gcloud storage buckets update gs://BUCKET_NAME --lifecycle-file=LIFECYCLE_CONFIG_FILE
Where:
BUCKET_NAMEis the name of the relevant bucket. For example,my-bucket.LIFECYCLE_CONFIG_FILEis the path for the JSON file that you updated in Step 2.
Client libraries
Setting a lifecycle configuration using the client libraries replaces any existing lifecycle rules on the bucket. If you want to retain existing rules, first get the current lifecycle configuration, and then include all the rules that you want to apply in your request.
For more information, see the
Cloud Storage C++ API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:
For more information, see the
Cloud Storage C# API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:
For more information, see the
Cloud Storage Go API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:
For more information, see the
Cloud Storage Java API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:
For more information, see the
Cloud Storage Node.js API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:
For more information, see the
Cloud Storage PHP API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:
For more information, see the
Cloud Storage Python API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:
For more information, see the
Cloud Storage Ruby API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket: The following sample sets a lifecycle configuration on a bucket: The following sample removes any existing lifecycle configuration from a bucket:C++
C#
Go
Java
Node.js
PHP
Python
Ruby
Rust
Terraform
You can use a Terraform resource to set a lifecycle
configuration for a bucket managed by Terraform. To set a lifecycle
configuration on an existing bucket that isn't yet managed by Terraform,
you must first import the existing bucket. Applying a Terraform
configuration replaces any existing lifecycle rules on the bucket; if you
want to retain existing rules, include all the lifecycle_rule blocks that
you want to apply in your google_storage_bucket resource.
To find out whether a lifecycle condition is supported by Terraform, see the
Terraform documentation for the condition block.
REST APIs
JSON API
Have gcloud CLI installed and initialized, which lets you generate an access token for the
Authorizationheader.If you want to retain existing lifecycle rules on the bucket, then get the current lifecycle configuration and save it to a JSON file. Otherwise, create a new JSON file.
Update the JSON file to include all the lifecycle configuration rules that you want to apply to the bucket. Applying a configuration file replaces any existing lifecycle rules on the bucket. For sample JSON files, see Configuration examples.
Use
cURLto call the JSON API with aPATCHBucket request:curl -X PATCH --data-binary @LIFECYCLE_CONFIG_FILE \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ -H "Content-Type: application/json" \ "https://storage.googleapis.com/storage/v1/b/BUCKET_NAME?fields=lifecycle"
Where:
LIFECYCLE_CONFIG_FILEis the path for the JSON file that you updated in Step 3.BUCKET_NAMEis the name of the relevant bucket. For example,my-bucket.
XML API
Have gcloud CLI installed and initialized, which lets you generate an access token for the
Authorizationheader.If you want to retain existing lifecycle rules on the bucket, then get the current lifecycle configuration and save it to an XML file. Otherwise, create a new XML file.
Update the XML file to include all the lifecycle configuration rules that you want to apply to the bucket. Applying a configuration file replaces any existing lifecycle rules on the bucket. For sample XML files, see Configuration examples.
Use
cURLto call the XML API with aPUTBucket request andlifecyclequery string parameter:curl -X PUT --data-binary @XML_FILE_NAME \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ "https://storage.googleapis.com/BUCKET_NAME?lifecycle"
Where:
XML_FILE_NAMEis the path for the XML file that you updated in Step 3.BUCKET_NAMEis the name of the relevant bucket. For example,my-bucket.
Get the lifecycle configuration for a bucket
Console
- In the Google Cloud console, go to the Cloud Storage Buckets page.
In the bucket list, the lifecycle status of each bucket is found in the Lifecycle column.
You can click this status to add, view, edit, and delete rules.
To learn how to get detailed error information about failed Cloud Storage operations in the Google Cloud console, see Troubleshooting.
Command line
Use the gcloud storage buckets describe command with the
--format flag:
gcloud storage buckets describe gs://BUCKET_NAME --format="default(lifecycle_config)"
Where BUCKET_NAME is the name of the bucket for
which you want to view the lifecycle configuration. For example,
my-bucket.
Client libraries
For more information, see the
Cloud Storage C++ API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
For more information, see the
Cloud Storage C# API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
For more information, see the
Cloud Storage Go API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
For more information, see the
Cloud Storage Java API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
For more information, see the
Cloud Storage Node.js API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
For more information, see the
Cloud Storage PHP API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
For more information, see the
Cloud Storage Python API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
For more information, see the
Cloud Storage Ruby API
reference documentation.
To authenticate to Cloud Storage, set up Application Default Credentials.
For more information, see
Set up authentication for client libraries.
C++
C#
Go
Java
Node.js
PHP
Python
Ruby
Rust
REST APIs
JSON API
Have gcloud CLI installed and initialized, which lets you generate an access token for the
Authorizationheader.Use
cURLto call the JSON API with aGETBucket request:curl -X GET \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ "https://storage.googleapis.com/storage/v1/b/BUCKET_NAME?fields=lifecycle"
Where
BUCKET_NAMEis the name of the relevant bucket. For example,my-bucket.
XML API
Have gcloud CLI installed and initialized, which lets you generate an access token for the
Authorizationheader.Use
cURLto call the XML API with aGETBucket request and alifecyclequery string parameter:curl -X GET \ -H "Authorization: Bearer $(gcloud auth print-access-token)" \ "https://storage.googleapis.com/BUCKET_NAME?lifecycle"
Where
BUCKET_NAMEis the name of the relevant bucket. For example,my-bucket.
What's next
- Learn more about Object Lifecycle Management, including the available lifecycle actions and lifecycle conditions.
- Explore lifecycle configuration examples.